//+------------------------------------------------------------------+
//|                                                    The Abyss.mq4 |
//|                                Copyright  2007,Richard Benson . |
//|                                        
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#include <stdlib.mqh>

extern int  MagicNumber=197893;
extern string EAName="The Abyss";

extern double ProfitExit = 100; //% profit exit

extern double Open_Loss_To_CloseTrades=-1000;

extern double EquityGainPercent = 10; //Global percentage of equity exit

extern string  D ="Heiken Ashi Smoothed";
extern string  has = "HAS Inputs";
extern int MaMethod  = 0;
extern int MaPeriod = 18;
extern int MaMethod2  = 3;
extern int MaPeriod2 = 2;

extern string  DT ="TrendManager";
extern int TM_Period = 20;
extern int TM_Shift = 2;


extern string  DS ="Slope Direction Line";
extern int       period=40;
extern int       method=2;
extern int       price=0;

extern int    ConsecutiveTrades=1;

extern double Lots = 0.01;
extern int    LotRound=1; //digits after decimal point for lot size
extern double MinLot = 0.01;    //minimum lot size
extern double MaximumRisk = 2; //% risk. lot size will be calculated so that stoploss was equal to risk% of balance
extern bool   FixedLot = false; //trigger to use MM

extern int    slippage=2;   	//slippage for market order processing
extern int    shift=0;			//shift to current bar for entry 
extern int    OrderTriesNumber=3;


bool buysig,sellsig,closebuy,closesell,cancel,addbuy,addsell,exit,Trade; 
int ord,tries,last,buys,sells,SL,co,mkt,lastsig;
double atrstop,atrentry,_1stentry,entryprice,_1stlots,avgpositionprofit,curprof,tickvalue;


int range = 5;
int multiplier;
int Slippage=5;


int init()
  {

     //----------------------- GENERATE MAGIC NUMBER AND TICKET COMMENT
//----------------------- SOURCE : PENGIE
   MagicNumber    = subGenerateMagicNumber(MagicNumber, Symbol(), Period());
   tickvalue = MarketInfo(Symbol(),MODE_TICKVALUE);
   
//----
   return(0);
  }
  

//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()  {

   //---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;

   //---- check for signals
   CheckForSignals();

   CheckForOpen();

{
double pcnt =( (AccountEquity()-AccountBalance()) / AccountBalance())*100;
Print("Account equity = ",AccountEquity());
Print("Account balance = ",AccountBalance());

 if(pcnt>EquityGainPercent)
 { 
int total = OrdersTotal();
  for(int i=total-1;i>=0;i--)
  {
    OrderSelect(i, SELECT_BY_POS);
    int type   = OrderType();

    bool result = false;
    
    switch(type)
    {
      //Close opened long positions
      case OP_BUY       : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
                          break;
      
      //Close opened short positions
      case OP_SELL      : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
                          break;

      //Close pending orders
      case OP_BUYLIMIT  :
      case OP_BUYSTOP   :
      case OP_SELLLIMIT :
      case OP_SELLSTOP  : result = OrderDelete( OrderTicket() );
    }
    
    if(result == false)
    {
      Alert("Order " , OrderTicket() , " failed to close. Error:" , GetLastError() );
      Sleep(3000);
    }  
  }
  
 
     Print("ALL ORDERS CLOSE-->Locked in on Profits");
 }
 return(0);
 if (AccountProfit()<= Open_Loss_To_CloseTrades)
   {
    for(i=OrdersTotal()-1;i>=0;i--)
       {
              
       switch(type)
          {
          //Close opened long positions
          case OP_BUY  : result = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),Slippage,Pink);
                         break;
               
          //Close opened short positions
          case OP_SELL : result = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),Slippage,Pink);
                          
          }
          
       if(result == false)
          {
            Sleep(3000);
          }  
       }
      Print ("Account Cutoff Limit Reached. All Open Trades Have Been Closed");
      return(0);
   }  
   
   Comment("Balance: ",AccountBalance(),", Account Equity: ",AccountEquity(),", Account Profit: ",AccountProfit(),
           "\nMy Account Cutoff Limit: ",Open_Loss_To_CloseTrades);
   
  return(0);
}

  }
       


///+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders()  {
   buys=0; sells=0;
   string symbol=Symbol();
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) continue;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
        {
         if(OrderType()==OP_BUY || OrderType()==OP_BUYSTOP)  buys++;
         if(OrderType()==OP_SELL || OrderType()==OP_SELLSTOP) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
}
double LotsRisk(int StopLoss)  { 
   //MM lot size calculation
   int sl=StopLoss;
   if (sl==0) sl=100;
   double lot=Lots;
//---- select lot size
   if (!FixedLot)
      lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk*0.001/sl,LotRound);
   else
      lot=Lots;
//---- return lot size
   if(lot<MinLot) lot=MinLot;
   return(lot);
}

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForSignals() {


      buysig=false;
      sellsig=false;
      closebuy=false;
      closesell=false;
      exit=false;

      
      	



      double TML=iCustom(NULL,0,"TrendManager",TM_Period,TM_Shift,1);
    	double TMS=iCustom(NULL,0,"TrendManager",TM_Period,TM_Shift,0);
   	double hasOpen = iCustom(NULL,0,"Heiken_Ashi_Smoothed",MaMethod,MaPeriod,MaMethod2,MaPeriod2,1) ;
      double hasClose = iCustom(NULL,0,"Heiken_Ashi_Smoothed",MaMethod,MaPeriod,MaMethod2,MaPeriod2,0) ;
      double SDLL = iCustom(NULL,0,"Slope Direction Line",period,method,price,0) ;
      double SDLS = iCustom(NULL,0,"Slope Direction Line",period,method,price,1) ;


      bool Long1 = SDLL;
      bool Short1 = SDLS;
      bool Long2 = TML;
      bool Short2 = TMS;
      bool Long3 = hasOpen > hasClose;
      bool Short3 = hasOpen < hasClose;
      

      buysig = Long1 == Long2 == Long3;
      sellsig = Short1 == Short2 == Short3;

      closebuy=sellsig;
      closesell=buysig;
      
            if (curprof>=AccountFreeMargin()*ProfitExit/100.0) {
         exit=true;
      }
      

      }

void CheckForOpen() {

   if (last==Time[0]) return;

   int    res,ord;
   double entry,stop,profit;

   ord=CalculateCurrentOrders();

   if (ord!=0) CheckForClose();

   ord=CalculateCurrentOrders();

//---- buy conditions
   if (ord==0 && buysig)  {
		res=OpenAtMarket(OP_BUY,LotsRisk(SL));
		if (res<0) Print("Error opening BUY order : ",ErrorDescription(GetLastError()));
		else { last=Time[0]; _1stlots=LotsRisk(SL); _1stentry=entryprice;  }
   }
//---- sell conditions
   if (ord==0 && sellsig)  {
		res=OpenAtMarket(OP_SELL,LotsRisk(SL));
		if (res<=0) Print("Error opening SELL order : ",ErrorDescription(GetLastError()));
		else { last=Time[0]; _1stlots=LotsRisk(SL); _1stentry=entryprice;  }
   }
}
  
int OpenAtMarket(int mode,double lot) {
   int    res,tr,col;
   double openprice,sl,tp;
   tries=0;
   while (res<=0 && tries<OrderTriesNumber) {
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
      RefreshRates();
      if (mode==OP_SELL) {
         openprice=Bid; 
         col=Red;
      } else {
         //openprice=nd(Ask);
         openprice=Ask;
         col=Blue;
      }
      res=OrderSend(Symbol(),mode,lot,openprice,slippage,sl,tp,EAName+MagicNumber,MagicNumber,0,col);
      tries++;
   }
   return(res);
}
  
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()  {
	int total;
//----
	total=OrdersTotal();
   for(int i=total;i>=0;i--)
   //for(int i=0;i<total;i++)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))  continue;
      if(OrderMagicNumber()!=MagicNumber || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY  && closebuy) CloseAtMarket(OrderTicket(),OrderLots());
      if(OrderType()==OP_SELL  && closesell) CloseAtMarket(OrderTicket(),OrderLots());
     }

   //int ord=CalculateCurrentOrders();
   //if (ord!=0) CheckForClose();
}

bool CloseAtMarket(int ticket,double lot) {
   bool bres=false; int tr;
   tries=0;
   while (!bres && tries<OrderTriesNumber) {
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
      RefreshRates();
      bres=OrderClose(ticket,lot,OrderClosePrice(),slippage,White);
      if (!bres) Print("Error closing order : ",ErrorDescription(GetLastError()));
      tries++;
   }
}


//+------------------------------------------------------------------+
//+--------------------------END OF PROGRAM--------------------------+


//----------------------- GENERATE MAGIC NUMBER BASE ON SYMBOL AND TIME FRAME FUNCTION
//----------------------- SOURCE   : PENGIE

int subGenerateMagicNumber(int MagicNumber, string symbol, int timeFrame)
{
   int isymbol = 0;
   if (symbol == "EURUSD")       isymbol = 1;
   else if (symbol == "GBPUSD")  isymbol = 2;
   else if (symbol == "USDJPY")  isymbol = 3;
   else if (symbol == "USDCHF")  isymbol = 4;
   else if (symbol == "AUDUSD")  isymbol = 5;
   else if (symbol == "USDCAD")  isymbol = 6;
   else if (symbol == "EURGBP")  isymbol = 7;
   else if (symbol == "EURJPY")  isymbol = 8;
   else if (symbol == "EURCHF")  isymbol = 9;
   else if (symbol == "EURAUD")  isymbol = 10;
   else if (symbol == "EURCAD")  isymbol = 11;
   else if (symbol == "GBPUSD")  isymbol = 12;
   else if (symbol == "GBPJPY")  isymbol = 13;
   else if (symbol == "GBPCHF")  isymbol = 14;
   else if (symbol == "GBPAUD")  isymbol = 15;
   else if (symbol == "GBPCAD")  isymbol = 16;
   else                          isymbol = 17;
   if(isymbol<10) MagicNumber = MagicNumber * 10;
   return (StrToInteger(StringConcatenate(MagicNumber, isymbol, timeFrame)));
   
}


